   CLS
10 PRINT " DXFOPT v1.3"
20 PRINT " ==========="
30 PRINT " Programme to read named DXF file and write nodes to OPT file"
   PRINT
   REM Relies on previous creation of file by OPTDXF containing the face
   REM node numbers for each face - this info is lost on conversion to DXF
   REM (face nodes are stored as XYZs not node numbers).
   REM Updates this version:
   REM - Fixes DXF read error from AUTOCAD-created large DXFs e.g. SSD.OPT.
   REM - Larger array sizes, handles bigger models.
   REM
   REM Known limitations:
   REM
   REM FAQ
   REM - OPT is wildly corrupted! A: you're probably using a dxf editor that
   REM   jumbles face order on outputting modified DXF. Use PROTOCAD or AUTOCAD.
   REM - OPT is somewhat corrupted, esp. where I've been editing. A: you can
   REM   only STRETCH, not create, delete, detatch. READ THE README!
   REM
   REM  Eyepoint,sightpoint,transform matrix, perspective (2/3 point) and
   REM  eye angle are read from VIEW.DAT.
   REM  Use VIEW.BAS to create VIEW.DAT
   REM
   PRINT "another humble offering by Lt Hag"
   PRINT "Please feel free to use this code and information to create new "
   PRINT "FREEWARE programs - and PLEASE send utilities and SOURCE CODE"
   PRINT "to the OPT project!"


   DIM STR AS STRING * 4000
   DIM COORD(1000) AS SINGLE
   DIM XYZ(333, 4) AS SINGLE
   DIM NODES(2400, 3), TRIS(800, 4), ONODES(1000, 4), OTRIS(800, 5)
   DIM MIN(3), MAX(3), PNTS(3, 3)
   DIM S1 AS STRING * 1
   DIM ST AS STRING * 7
   DIM SN AS STRING * 4
   DIM S4 AS STRING * 4
   DIM S2 AS STRING * 2
   DIM faces AS STRING * 64
   DIM FACENODES(16) AS LONG
   DIM MYST AS LONG
   MAXNODES = 2400: MAXTRIS = 800: MAXONODES = 1000
   LASTCOL = 80: LASTROW = 30
   XPIXELS = 640: YPIXELS = 480: SMODE = 11
   PI = 3.1415927#
   NNODES = 0
   NTRIS = 0
   NODESET = 0

   REM ON ERROR GOTO 70
   FILES "*.DXF": PRINT
70 REM continue
   INPUT "GIVE DXF FILE (INCL. EXT'N): ", A$
80 OPEN A$ FOR INPUT AS #2
   FILES "*.TXT": PRINT
   INPUT "GIVE TRIS FILE (INCL. EXT'N): ", A$
   OPEN A$ FOR INPUT AS #1
   FILES "*.OPT": PRINT
   INPUT "Give OPT file:", PFILE$
   PRINT PFILE$
   OPEN PFILE$ FOR BINARY AS #9
   GET #9, 5, S4: REM Read recorded file length
   LSF = CVL(MID$(S4, 1, 4)) + 8
   PRINT "OPT length="; LSF

   REM Initialise
  
120 FOR I = 1 TO MAXONODES
130   FOR J = 1 TO 4
140     ONODES(I, J) = 0
150   NEXT J
160 NEXT I

    REM Get DXF info
    PRINT : PRINT "Reading DXF file..."
    GOSUB 1000
    REM INPUT "Pause..."; A$
    
    REM Read Opt Faces
    INPUT #1, NOTRIS
    PRINT : PRINT Reading; ";NOTRIS;"; OPT; faces...; ""
    FOR IT = 1 TO NOTRIS
      INPUT #1, OTRIS(IT, 1), OTRIS(IT, 2), OTRIS(IT, 3), OTRIS(IT, 4)
      PRINT IT; OTRIS(IT, 1); OTRIS(IT, 2); OTRIS(IT, 3); OTRIS(IT, 4)
      REM debug IF IT > 208 AND IT < 214 THEN INPUT "Pause..."; A$
    NEXT IT
    REM INPUT "Pause..."; A$

    IF NOTRIS <> NTRIS THEN
       PRINT "================================================================="
       PRINT "WARNING!!!! No. faces in TRIS="; NOTRIS; "No. in DXF="; NTRIS
       PRINT "================================================================="
    END IF
   
    REM set up nodes in ONODES for reinsertion into OPT
    
    MAXON = 0: REM Pick up max. OPT node
    FOR IT = 1 TO NTRIS
	FOR IN = 1 TO 4
		FOR IC = 1 TO 3
		   ONODES(OTRIS(IT, IN), IC) = NODES(TRIS(IT, IN), IC)
		NEXT IC
		IF TRIS(IT, IN) > MAXON THEN MAXON = TRIS(IT, IN)
		ONODES(OTRIS(IT, IN), 4) = 1: REM this node is set
	NEXT IN
    NEXT IT

    REM Scan OPT, reinsert nodes

    REM Find next Node set, get no. of nodes in set NNSET , start, finish offsets
    PRINT
    PRINT "SCANNING OPT FILE..."
    SFPOS = 1
    NTRIS = 0
    NONODES = 0: REM No. of OPT nodes
1520 REM Get next 4 bytes, starting at SFPOS
     GET #9, SFPOS, S4
     REM check for node header - longs 0,3,0,0
     MYST = CVL(MID$(S4, 1, 4))
     IF MYST = 0 THEN
	GET #9, SFPOS + 4, S4
	MYST = CVL(MID$(S4, 1, 4))
	IF MYST = 3 THEN
	   GET #9, SFPOS + 8, S4
	   MYST = CVL(MID$(S4, 1, 4))
	   IF MYST = 0 THEN
	     GET #9, SFPOS + 12, S4
	     MYST = CVL(MID$(S4, 1, 4))
	     IF MYST = 0 THEN
		REM Found nodes!!
		SFPOS = SFPOS + 16
		PRINT "FOUND NODESET...INSERTING..."
		GOSUB 2100: REM set start/finish for nodes read
		GOSUB 1100: REM read nodes triplets
		REM GOSUB 1200: REM print to screen/file
		GOSUB 2600: REM substitute nodes from DXF
		REM GOSUB 1900: REM transform nodes for screen display
		REM INPUT "Pause..."; PAUSE$
	     END IF
	   END IF
	END IF
     END IF


     SFPOS = SFPOS + 1
     IF SFPOS > LSF GOTO 1599
      GOTO 1520


1599 REM All done! check had right number of nodes to reinsert :=)
     PRINT : PRINT "==================================================="
     PRINT "No. of nodes found in OPT = "; NONODES
     PRINT "Max. node from DXF file   = "; MAXON
     PRINT : PRINT "==================================================="

     END



    REM===================================================
    REM
1000 REM SCAN DXF FILE, LOAD DXFTRIS
    REM
    NNODES = 0: MAXNODE = 0: NTRIS = 0: LINENO = 0
    REM
    REM INPUT DATA FROM FILE
    REM
1240 INPUT #2, A$
    LINENO = LINENO + 1
    IF A$ = "3DFACE" THEN GOSUB 2000: GOTO 1240
    IF EOF(2) THEN 1310
    GOTO 1240

1310 REM CONTINUE
    PRINT "DXF SCAN COMPLETE - "
    PRINT "NO. OF NODES = "; NNODES
    PRINT "NO. OF TRIS  = "; NTRIS
    RETURN

    REM-------------------------------------------------------------
     REM
     REM Found a 3DFACE! read.
     REM
2000 PRINT : PRINT "3DFACE FOUND - #"; NTRIS + 1
2200 INPUT #2, A$
     LINENO = LINENO + 1
     REM IF INSTR(1, A$, "10") > 0 GOTO 2300
     IF RIGHT$(A$, 2) <> "10" GOTO 2200
     IF LEN(A$) > 2 AND LEFT$(A$, 1) = "1" GOTO 2200

2300 REM CONTINUE
     REM
     REM Input face
     REM
     FOR I = 1 TO 4
       NNODES = NNODES + 1
       FOR J = 1 TO 3
	  INPUT #2, NODES(NNODES, J)
	  INPUT #2, A$
	  LINENO = LINENO + 2
       NEXT J
     NEXT I
     NTRIS = NTRIS + 1
     REM
     TRIS(NTRIS, 1) = NNODES - 3: TRIS(NTRIS, 2) = NNODES - 2: TRIS(NTRIS, 3) = NNODES - 1: TRIS(NTRIS, 4) = NNODES
     RETURN


1100 REM Read triplets between START and FINISH
   LENGTH = FINISH - START + 1
   REM PRINT "Start = "; START
   REM PRINT "Finish= "; FINISH
   REM PRINT "Length in BYTES:"; LENGTH
   REM PRINT "Length in FLOAT:"; LENGTH / 4
   REM INPUT "Pause...:"; A$
   REM
   GET #9, START, STR: REM Read data
   REM
   REM----------------------------------------------------------------
    REM PRINT "ECHO:"
    CI = 0
    FOR I = 1 TO LENGTH STEP 4
       CI = CI + 1
       COORD(CI) = CVS(MID$(STR, I, 4))
       REM PRINT "COORD "; CI; " IS "; COORD(CI)
    NEXT I
    REM TNODES = CI / 3
    REM FOR IJK = 1 TO TNODES
    REM   J = PREVNODES + IJK
    REM   NODES(J, 1) = COORD((IJK - 1) * 3 + 1)
    REM   NODES(J, 2) = COORD((IJK - 1) * 3 + 2)
    REM    NODES(J, 3) = COORD((IJK - 1) * 3 + 3)
    REM   NODES(J, 4) = 1
    REM NEXT IJK
    RETURN


1200 REM Print triplets to screen
     FOR IN = (PREVNODES + 1) TO NNODES
       PRINT IN; NODES(IN, 1); ","; NODES(IN, 2); ","; NODES(IN, 3)
     NEXT IN
     PRINT
     RETURN


2100 REM Set start and finish to read nodes
    GET #9, SFPOS, S4: REM Read no. of nodes
    PREVNODES = NONODES
    NNSET = CVL(MID$(S4, 1, 4))
    REM PRINT "No. of nodes this node set = "; NNSET
    NODESET = NODESET + 1
    NONODES = NNSET + PREVNODES
    REM PRINT "TOTAL No. of OPT nodes to be inserted so far = "; NONODES
    REM INPUT "Pause..."; a$
    START = SFPOS + 8
    FINISH = START + NNSET * 3 * 4 - 1
    RETURN

2600 REM
    REM Put appropriate nodes for this set into XYZ
    PNODES = NONODES - NNSET: REM no. of nodes previously written
    FOR I = 1 TO NNSET
      INODE = I + PNODES
      FOR J = 1 TO 4
	XYZ(I, J) = ONODES(INODE, J)
      NEXT J
    NEXT I
    REM Put triplets back into single line
    REM Skip nodes not set = not called up in a face
    FOR J = 1 TO NNSET
       IF XYZ(J, 4) <> 1 THEN GOTO 2610
       COORD((J - 1) * 3 + 1) = XYZ(J, 1)
       COORD((J - 1) * 3 + 2) = XYZ(J, 2)
       COORD((J - 1) * 3 + 3) = XYZ(J, 3)
       REM PRINT J + PNODES; J; : FOR K = 1 TO 3: PRINT XYZ(J, K); : NEXT K: PRINT
2610 NEXT J
    REM reconvert to string and put back to file
    CI = 0
    FOR I = 1 TO LENGTH STEP 4
       CI = CI + 1
       MID$(STR, I, 4) = MKS$(COORD(CI))
       REM PRINT "COORD "; CI; " IS "; COORD(CI)
    NEXT I
    REM PRINT "About to re-put Nodeset "; NODESET; ", NNSET="; NNSET; ", MAX NN="; INODE
    REM PRINT "PUTting to 0-offset :"; START - 1
    REM IF INODE > 380 THEN INPUT "PAUSE..."; ANS$
    PUT #9, START, STR
    RETURN

